﻿Imports System.Runtime.InteropServices
Imports System
Imports System.IO
Imports System.Text

' Please read the included file "important_notes_for_NET_developers_on_using_WSQ_image_library.html"
' or the page: 
' http://cognaxon.com/index.php?page=wsqlib_NETnotes
' FAQ (Frequently Asked Questions)
' for .NET developers on using WSQ image library


Public Class Form1

    Dim hbitmap As IntPtr

    Private WSQ_library_native_methods As WSQImageLibraryNativeMethods

    Private bp As IntPtr
    Private b As System.Drawing.Bitmap

    Private type8_image_compression_type As Int64
    Private result_string As String
    Private save_type8_binary_field_filename As String
    Private image_size_txt_file As String

    Private type8_binary_field_ptr As IntPtr
    Private type8_binary_field As Byte()
    Private type8_binary_field_length As Int64

    Private type8_image_width As Int64
    Private type8_image_height As Int64

    Private input_data_stream As Byte()
    Private input_data_stream2 As Byte()
    Private output_data_stream As Byte()
    Private output_data_stream2 As Byte()
    Private pwidth As Int64
    Private pheight As Int64
    Private ppi As Int64
    Private comment_text As String
    Private bitrate As Double
	Private utf8 As New UTF8Encoding

    Private h, w As Int64


    'To call functions from WSQ_library.dll
    'you can use the methods from wrapper class WSQImageLibraryNativeMethods
    'or you can use function prototypes provided below 

    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
    Shared Function CreateNISTType8BinaryFieldfromHBITMAP(ByVal input_HBITMAP As IntPtr, ByVal type8_binary_field_compression_type As Int64) As IntPtr
    End Function

    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
    Shared Function CreateHBITMAPfromNISTType8BinaryField(ByVal type8_image_width As Int64, ByVal type8_image_height As Int64, ByVal type8_compression_type As Int64, <[In]()> ByVal type8_input_byte_array As Byte(), ByVal type8_input_byte_array_size As Int64) As IntPtr
    End Function

    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
    Shared Function ReadSizeOfNISTType8BinaryField() As Int64
    End Function

    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
    Shared Function ReadType8DataCompressionType() As Int64
    End Function

    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
    Shared Function ReadType8DataWidth() As Int64
    End Function

    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
    Shared Function ReadType8DataHeight() As Int64
    End Function

    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
    Shared Function SetNISTType8ImageColorInversion(ByVal in_uncompressed_type8_image_inverted As Int64, ByVal out_uncompressed_type8_image_inverted As Int64, ByVal in_compressed_type8_image_inverted As Int64, ByVal out_compressed_type8_image_inverted As Int64) As Int64
    End Function



    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
    Shared Function CreateBMPFromFile(ByVal FileName As Byte()) As IntPtr
    End Function

    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
    Shared Function SaveBMPToFile(ByVal hBitmap As IntPtr, ByVal FileName As Byte(), ByVal ifiletype As Short) As Int64
    End Function

    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
    Shared Sub SetShowFilePropertiesDialog(ByVal file_properties_dialog As Integer)
    End Sub

    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
    Shared Sub ShowFileConverter()
    End Sub

    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
    Shared Function ConvertHBITMAPtoGrayScale256(ByVal hBitmap As IntPtr) As IntPtr
    End Function

    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
    Shared Function SaveHBITMAPtoFileAsGrayScale256BMP(ByVal hBitmap As IntPtr, ByVal FileName As Byte()) As Int64
    End Function

    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
    Shared Function GenerateWSQLibrarySerialNumber() As IntPtr
    End Function

    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
    Shared Function UnlockWSQLibrary(ByVal lpszAuthorizationCode As String) As Short
    End Function



    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        WSQ_library_native_methods = New WSQImageLibraryNativeMethods

        type8_binary_field_ptr = IntPtr.Zero

        comboBoxCompression.Items.Add("Uncompressed")
        comboBoxCompression.Items.Add("ANSI/EIA-538-1988 facsimile compression")
        comboBoxCompression.SelectedIndex = 0

        textBoxWidth.Text = "0"
        textBoxHeight.Text = "0"


    End Sub


    Private Sub buttonOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonOpen.Click

            OpenFileDialog1.Filter = "All images|*.wsq;*.bmp;*.tiff;*.tif;*.jpg;*.jpeg;*.jp2;*.jpc;" & _
"*.png;*.gif;*.tga;*.pcx;*.ppm;*.pgm;*.pbm;*.ico;*.wmf;*.wbmp;*.ska;*.mng;*.pnm;*.ras;*.raw;|" & _
"FBI's Wavelet Scalar Quantization (*.wsq)|*.wsq|" & _
"Windows Bitmap Graphics (*.bmp)|*.bmp|" & _
"Macintosh Tagged Information File Format images (*.tiff)|*.tiff|" & _
"PC Tagged Information File Format images (*.tif)|*.tif|" & _
"Joint Photographic Experts Group images (*.jpg)|*.jpg|" & _
"Joint Photographic Experts Group images (*.jpeg)|*.jpeg|" & _
"JPEG2000 Part 1 images (*.jp2)|*.jp2|" & _
"JPEG2000 Code Stream images (*.jpc)|*.jpc|" & _
"Portable Network Graphics images (*.png)|*.png|" & _
"Compuserve Graphic Interchange Format images (*.gif)|*.gif|" & _
"Truevision Targa Graphic images (*.tga )|*.tga|" & _
"ZSoft Paintbrush images (PC Paintbrush Bitmap Graphic) (*.pcx)|*.pcx|" & _
"Portable Pixel Map Images (*.ppm)|*.ppm|" & _
"Portable Gray Map Images (*.pgm)|*.pgm|" & _
"Portable Bitmap Images (*.pbm)|*.pbm|" & _
"Windows Icons (*.ico)|*.ico|" & _
"Windows Metafiles (*.wmf)|*.wmf|" & _
"Wireless Bitmap File Format (*.wbmp)|*.wbmp|" & _
"SKA Format images (*.ska)|*.ska|" & _
"Muti-image Network Graphic Animation (*.mng)|*.mng|" & _
"PBM Portable Any Map Graphic Bitmap (*.pnm)|*.pnm|" & _
"Sun Graphic (*.ras)|*.ras|" & _
"RAW Graphic (*.raw)|*.raw"

        OpenFileDialog1.FilterIndex = 1

        If (OpenFileDialog1.ShowDialog() <> DialogResult.OK) Then
            Exit Sub
        End If


        'you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
        'hbitmap = CreateBMPFromFile(utf8.GetBytes(OpenFileDialog1.FileName))
        hbitmap = WSQ_library_native_methods.pCreateBMPFromFile(OpenFileDialog1.FileName)
        OutputPicture.Image = Bitmap.FromHbitmap(hbitmap)

        h = OutputPicture.Image.Height
        w = OutputPicture.Image.Width
        OutputPicture.SetBounds(0, 0, w, h)

        textBoxWidth.Text = Convert.ToString(w)
        textBoxHeight.Text = Convert.ToString(h)

        buttonSave.Enabled = True
        ConvertToType8Button.Enabled = True

    End Sub





    Private Sub buttonSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonSave.Click

        Dim iResult As Short

        ' Set filters.
        SaveFileDialog1.Filter = "WSQ Files (*.wsq)|*.wsq|" & _
"Windows BMP (*.bmp)|*.bmp|" & _
"TIFF Files (*.tif)|*.tif|" & _
"PNG Files (*.png)|*.png|" & _
"JPEG Files (*.jpg)|*.jpg|" & _
"Targa Files (*.tga)|*.tga|" & _
"SGI Files (*.rgb)|*.rgb|" & _
"JPEG-2000 Part-1 (*.jp2)|*.jp2|" & _
"JPEG-2000 Code Stream (*.jpc)|*.jpc|" & _
"PBM - Portable Bitmap Format (*.pbm)|*.pbm|" & _
"PGM - Portable Graymap Format (*.pgm)|*.pgm|" & _
"PPM - Portable Pixmap Format (*.ppm)|*.ppm|" & _
"GIF Files (*.gif)|*.gif|" & _
"PNM Files (*.pnm)|*.pnm|" & _
"RAS Files (*.ras)|*.ras|" & _
"MNG Files (*.mng)|*.mng|" & _
"PCX Files (*.pcx)|*.pcx"

        ' Specify default filter.
        SaveFileDialog1.FilterIndex = 1

        SaveFileDialog1.FileName = ""


        If (SaveFileDialog1.ShowDialog() <> DialogResult.OK) Then
            Exit Sub
        End If


        'you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
        'SetShowFilePropertiesDialog(1)
        WSQ_library_native_methods.pSetShowFilePropertiesDialog(1)

        'you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
        'iResult = SaveBMPToFile((New Bitmap(OutputPicture.Image)).GetHbitmap(), utf8.GetBytes(SaveFileDialog1.FileName), SaveFileDialog1.FilterIndex)
        iResult = WSQ_library_native_methods.pSaveBMPToFile((New Bitmap(OutputPicture.Image)).GetHbitmap(), SaveFileDialog1.FileName, SaveFileDialog1.FilterIndex)

        'Dim objBitmap As Bitmap
        'objBitmap = OutputPicture.Image
        'iResult = SaveBMPToFile(objBitmap.GetHbitmap(), SaveFileDialog1.FileName, SaveFileDialog1.FilterIndex)


    End Sub

    Private Sub ConvertFromType8Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ConvertFromType8Button.Click


        ConvertToType8Button.Enabled = False
        ConvertFromType8Button.Enabled = False
        buttonOpen.Enabled = False
        buttonSave.Enabled = False


        OpenFileDialog1.Filter = "Type8 binary images|*.bin"

        OpenFileDialog1.FilterIndex = 1

        If (OpenFileDialog1.ShowDialog() <> DialogResult.OK) Then
            ConvertFromType8Button.Enabled = True
            buttonOpen.Enabled = True
            Exit Sub
        End If


        image_size_txt_file = Path.ChangeExtension(OpenFileDialog1.FileName, ".txt")

        If (File.Exists(image_size_txt_file)) Then

            ' Create an instance of StreamReader to read from a file.
            ' The using statement also closes the StreamReader.
            Dim sr As System.IO.StreamReader
            sr = My.Computer.FileSystem.OpenTextFileReader(image_size_txt_file)

            type8_image_compression_type = Convert.ToInt64(sr.ReadLine())  ' type8_image_compression_type = int.Parse(sr.ReadLine())
            type8_image_width = Convert.ToInt64(sr.ReadLine())
            type8_image_height = Convert.ToInt64(sr.ReadLine())
            sr.Close()

            textBoxWidth.Text = Convert.ToString(type8_image_width)
            textBoxHeight.Text = Convert.ToString(type8_image_height)

            'if (File.Exists(image_size_txt_file)) 
        Else
            type8_image_width = Convert.ToInt64(textBoxWidth.Text)
            type8_image_height = Convert.ToInt64(textBoxHeight.Text)
        End If


        If ((type8_image_width = 0) Or (type8_image_height = 0)) Then
            MessageBox.Show("You must manually set the type8_image_width and type8_image_height and compression type of the image.")
            ConvertFromType8Button.Enabled = True
            buttonOpen.Enabled = True
            Return
        End If


        comboBoxCompression.SelectedIndex = type8_image_compression_type


        Dim fInfo As IO.FileInfo = New IO.FileInfo(OpenFileDialog1.FileName)
        Dim input_stream_length As Long = fInfo.Length
        Dim fStream As IO.FileStream = New IO.FileStream(OpenFileDialog1.FileName, IO.FileMode.Open, IO.FileAccess.Read)
        Dim br As IO.BinaryReader = New IO.BinaryReader(fStream)

        input_data_stream = br.ReadBytes(input_stream_length)


        bp = CreateHBITMAPfromNISTType8BinaryField(type8_image_width, type8_image_height, type8_image_compression_type, input_data_stream, input_stream_length)

        b = Image.FromHbitmap(bp)
        OutputPicture.Image = b

        h = OutputPicture.Image.Height
        w = OutputPicture.Image.Width
        OutputPicture.SetBounds(0, 0, w, h)


        ConvertToType8Button.Enabled = True
        ConvertFromType8Button.Enabled = True
        buttonOpen.Enabled = True
        buttonSave.Enabled = True



    End Sub


    Private Sub ConvertToType8Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ConvertToType8Button.Click


        ConvertToType8Button.Enabled = False
        ConvertFromType8Button.Enabled = False


        ' Set filters.
        SaveFileDialog1.Filter = "BIN Files (*.bin)|*.bin"

        ' Specify default filter.
        SaveFileDialog1.FilterIndex = 1

        SaveFileDialog1.FileName = ""


        If (SaveFileDialog1.ShowDialog() <> DialogResult.OK) Then
            ConvertToType8Button.Enabled = True
            ConvertFromType8Button.Enabled = True
            Exit Sub
        End If


        type8_image_width = Convert.ToInt64(textBoxWidth.Text)
        type8_image_height = Convert.ToInt64(textBoxHeight.Text)
        type8_image_compression_type = comboBoxCompression.SelectedIndex

        image_size_txt_file = Path.ChangeExtension(SaveFileDialog1.FileName, ".txt")



        Dim sw As System.IO.StreamWriter
        sw = My.Computer.FileSystem.OpenTextFileWriter(image_size_txt_file, True)
        sw.WriteLine(type8_image_compression_type.ToString())
        sw.WriteLine(type8_image_width.ToString())
        sw.WriteLine(type8_image_height.ToString())
        sw.Close()


        b = New Bitmap(OutputPicture.Image)
        bp = b.GetHbitmap()

        save_type8_binary_field_filename = Path.ChangeExtension(SaveFileDialog1.FileName, ".bin")

        type8_binary_field_ptr = CreateNISTType8BinaryFieldfromHBITMAP(bp, type8_image_compression_type)
        type8_binary_field_length = ReadSizeOfNISTType8BinaryField()

        'MessageBox.Show(type8_binary_field_length.ToString())

        Dim type8_binary_field(type8_binary_field_length) As Byte

        Marshal.Copy(type8_binary_field_ptr, type8_binary_field, 0, type8_binary_field_length)


        'Dim fStream As IO.FileStream = New IO.FileStream(save_type8_binary_field_filename, IO.FileMode.CreateNew)
        Dim fStream As IO.FileStream = New IO.FileStream(save_type8_binary_field_filename, IO.FileMode.Create)
        Dim bw As IO.BinaryWriter = New IO.BinaryWriter(fStream)

        bw.Write(type8_binary_field)
        bw.Close()
        fStream.Close()

        result_string = "The converted file was saved as:" & vbCrLf & save_type8_binary_field_filename
        MessageBox.Show(result_string)

        ConvertToType8Button.Enabled = True
        ConvertFromType8Button.Enabled = True

    End Sub
End Class
